//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Generator.Test.TestReference
{


    ///  <summary>
    /// Class that implements the IRxService interface through SiLA2
    /// </summary>
    public partial class RxServiceClient : IRxService
    {

        private IClientExecutionManager _executionManager;

        private IClientChannel _channel;

        private const string _serviceName = "sila2.tecan.sila.generator.test.testreference.rxservice.v4.RxService";

        ///  <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public RxServiceClient( IClientChannel channel, IClientExecutionManager executionManager )
        {
            _executionManager = executionManager;
            _channel = channel;
        }

        ///  <inheritdoc />
        public virtual System.IObservable<bool> RunRxObservable()
        {
            RunRxObservableRequestDto request = new RunRxObservableRequestDto( null );
            request.Validate();
            return new CommandObservable<bool>( _channel.ExecuteIntermediatesCommand<RunRxObservableRequestDto, bool, RunRxObservableIntermediateDto>( _serviceName, "RunRxObservable", request, ConvertRunRxObservableIntermediate, ConvertRunRxObservableException, _executionManager.CreateCallOptions( request.CommandIdentifier ) ) );
        }

        ///  <summary>
        /// Converts the error ocurred during execution of RunRxObservable to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertRunRxObservableException( string errorIdentifier, string errorMessage )
        {
            return null;
        }

        ///  <summary>
        /// Unwraps the response of the RunRxObservableIntermediate command
        /// </summary>
        /// <param name="value">The response data transfer object</param>
        /// <returns>The actual response</returns>
        private bool ConvertRunRxObservableIntermediate( RunRxObservableIntermediateDto value )
        {
            return value.Intermediate.Extract( _executionManager.DownloadBinaryStore );
        }

        private T Extract<T>( Tecan.Sila2.ISilaTransferObject<T> dto )

        {
            return dto.Extract( _executionManager.DownloadBinaryStore );
        }
    }

    ///  <summary>
    /// Factory to instantiate clients for the Rx Service.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute( typeof( IClientFactory ) )]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute( System.ComponentModel.Composition.CreationPolicy.Shared )]
    public partial class RxServiceClientFactory : IClientFactory
    {

        ///  <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "tecan.sila.generator.test/testreference/RxService/v4";
            }
        }

        ///  <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof( IRxService );
            }
        }

        ///  <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient( IClientChannel channel, IClientExecutionManager executionManager )
        {
            return new RxServiceClient( channel, executionManager );
        }
    }
}

